<script setup>
import { useInstrumentStore } from '../stores/instrument.js'

// UI stuff
import { CdxButton } from '@wikimedia/codex';
import { useRouter } from 'vue-router'
import { toast } from 'vue3-toastify';
import 'vue3-toastify/dist/index.css';
import { useCookies} from 'vue3-cookies';

// Import child form components
import Name from './form/Name.vue'
import Details from './form/Details.vue'
import Sampling from './form/Sampling.vue'
import Duration from './form/Duration.vue'
import Regulation from './form/Regulation.vue'
import Schema from './form/Schema.vue'

const { cookies } = useCookies();
const store = useInstrumentStore();
const router = useRouter()

store.formFunction = 'modify';

async function submit() {
    const formData = Object.assign({
        csrf_token: cookies.get('csrf_token'),
    }, store.instrument);

    const response = await store.updateInstrument(formData, 'update-instrument');
    toast(response.data.title, {
        type: response.success ? 'success' : 'error',
        position: 'bottom-right',
        autoClose: 2000,
    });
    if (response.success) {
        const instrumentName = formData.name;
        store.setSuccessMessage(`The instrument ${instrumentName} has been successfully updated. `);
        // Redirect to the List.vue
        router.push({ name: 'catalog' });
    }
}
</script>

<template>
    <Suspense>
        <div>
            <!-- HEADER -->
            <div class="subheader">
                <h1>Modify instrument: {{ store.instrument.name }}</h1>
                <div class="subtitle">
                    Use this form to configure your instrument. See the guide to
                    <a class="cdx-docs-link" target="_new" href="https://wikitech.wikimedia.org/wiki/Metrics_Platform/Measure_product_health">measuring product health</a>
                    for the steps that you need to complete before using this form.
                </div>
            </div>

            <div class="body">
                <form @submit.prevent="submit">
                    <!-- GET STARTED SECTION -->
                    <div class="section">
                        <Name />
                    </div>

                    <!-- DETAILS SECTION -->
                    <div class="section">
                        <Details />
                    </div>

                    <!-- SCHEMA SECTION -->
                    <div class="section">
                        <Schema />
                    </div>

                    <!-- Sampling -->
                    <div class="section">
                        <Sampling />
                    </div>

                    <!-- DURATION SECTION -->
                    <div class="section">
                        <Duration />
                    </div>

                    <!-- REGULATION SECTION -->
                    <div class="section">
                        <Regulation />
                    </div>

                    <!-- SUBMIT -->
                    <div class="section-last">
                        <cdx-button action="progressive" weight="primary" data-id="modify-submit">
                            Save configuration
                        </cdx-button>
                    </div>
                </form>
            </div>

        </div>
        <template #fallback>
            <div>Loading...</div>
        </template>
    </Suspense>

</template>
